<?php
    namespace Mvc\http;

    class Request {
        private const HTTP_GET = 'GET';
        private const HTTP_POST = 'POST';

        private $_aHttpParams = [];

        private $_controller;
        private $_action;
        private $_url;
        private $_baseUrl;

        public function _construct() {
            if (isset($_SERVEUR['REQUEST_URI']) == false || empty($_SERVEUR['REQUEST_URI']) == true) {
                throw new Exception("REQUEST_URI not found ");
            }

            $_url = $_SERVER['REQUEST_URI'];

            $_aHttpParams[self::HTTP_GET] = $_GET;
            $_aHttpParams[self::HTTP_POST] = $_POST;
        }

        /**
         * Get the value of _controller
         */ 
        public function get_controller()
        {
            return $this->_controller;
        }

        /**
         * Set the value of _controller
         *
         * @return  self
         */ 
        public function set_controller($_controller)
        {
            $this->_controller = $_controller;

            return $this;
        }

        /**
         * Get the value of _action
         */ 
        public function get_action()
        {
            return $this->_action;
        }

        /**
         * Set the value of _action
         *
         * @return  self
         */ 
        public function set_action($_action)
        {
            $this->_action = $_action;

            return $this;
        }

        /**
         * Get the value of _url
         */ 
        public function get_url()
        {
            return $this->_url;
        }

        /**
         * Set the value of _url
         *
         * @return  self
         */ 
        public function set_url($_url)
        {
            $this->_url = $_url;

            return $this;
        }

        /**
         * Get the value of _baseUrl
         */ 
        public function get_baseUrl()
        {
            return $this->_baseUrl;
        }

        /**
         * Set the value of _baseUrl
         *
         * @return  self
         */ 
        public function set_baseUrl($_baseUrl)
        {
            $this->_baseUrl = $_baseUrl;

            return $this;
        }

        public function isPost()
        {
            return ($_SERVER['REQUEST_METHOD'] == self::HTTP_POST);
        }

        public function __call($sMethod, array $aArgs)
        {
            /*
                * Récupère les arguments
                */
            $sKey = null;
            $sValue = null;        if (isset($aArgs[0])) {
                $sKey = $aArgs[0];
            }
            if (isset($aArgs[1])) {
                $sValue = $aArgs[1];
            }

            /*
             * Récupère l'action et le paramètre
             */
            $sAction = strtolower(substr($sMethod, 0, 3));
            $sHttpParam = strtoupper(substr($sMethod, 3));        /*
                * Appelle la bonne méthode
                */
            if ('get' === $sAction) {
                switch ($sHttpParam) {
                    case self::HTTP_GET :
                    case self::HTTP_POST :
                        return $this->{'_getHttpParams'}($sHttpParam, $sKey, $sValue);
                        break;
                    default :
                        throw new Request\Exception("Type de superglobale ($sHttpParam) non géré");
                }
            }
            
            throw new Request\Exception('Méthode inconnue');
        }

        /**
        * Récupère un paramètre ou l'ensemble des paramètres
        *
        * @param string $sHttpParam (type de superglobale)
        * @param string optional $sKey (si pas de clé passé la superglobale est récupérée dans sa totalité)
        * @param string optional $sDefaultValue
        *
        * @return string
        */
        private function _getHttpParams($sHttpParam, $sKey = null, $sDefaultValue = null)
        {
            if (null === $sKey) {
                return $this->_aHttpParams[$sHttpParam];
            }

            return (isset($this->_aHttpParams[$sHttpParam][$sKey])) ? $this->_aHttpParams[$sHttpParam][$sKey] : $sDefaultValue;
        }
    }
?>